Attribute VB_Name = "FunctionsMod"
'#################################################################
'##           _      _____ __  __ _           _'
'##     /\   | |    |_   _|  \/  | |         | | ActiveX Control
'##    /  \  | |      | | | \  / | |__   ___ | |_
'##   / /\ \ | |      | | | |\/| | '_ \ / _ \| __|
'##  / ____ \| |____ _| |_| |  | | |_) | (_) | |_
'## /_/    \_\______|_____|_|  |_|_.__/ \___/ \__|
'##
'## Copyright (C) 2002-03, Mohammed Faizul Wahid
'##
'## This program is free software; you can redistribute it and/or
'## modify it under the terms of the GNU General Public License
'## as published by the Free Software Foundation; either version 2
'## of the License, or any later version.
'##
'## All copyright notices regarding ALIMBot ActiveX Control
'## must remain intact in the source code.
'##
'## This program is distributed in the hope that it will be useful,
'## but WITHOUT ANY WARRANTY; without even the implied warranty of
'## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'## GNU General Public License for more details.
'##
'## You should have received a copy of the GNU General Public
'## License along with this program; if not, write to the Free
'## Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
'## MA  02111-1307, USA.
'##
'## Support can be obtained from support forums at:
'## http://faizulwahid.tripod.com/alimbot/
'##
'## Correspondence and Questions can be sent to:
'## faiz_wahid@yahoo.com
'##
'#################################################################
'API declaration for running hyperlinks by default and starting programs
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Function runapp(ByVal filepath As String) As Boolean
Dim myvisible As Integer
myvisible = 1 'if you want invisibly then turn to 0 else 1
    Call ShellExecute(0, "Open", Trim(filepath), "", "c:\", myvisible)
End Function

'Function to find if the word exists in a string
'This is necessary in replacement of InStr()
'For Example
'If word="a" and strin="my name" then
'InStr() will return the true since alphabet "a" is there in "my name"
'But, IsWordInString() will return 0 since word a is not there in "my name"
'and will return the location of the first occurence of the word in the string
Function IsWordInString(strin As String, ByVal word As String, ByVal separator As String) As Integer
Dim strArr() As String
Dim wd As Variant
Dim loc, wordloc As Integer
wordloc = 0
strArr = Split(strin, separator)

For Each wd In strArr
    loc = Len(wd) + 1
    If wd = word Then 'if no word matches
        wordloc = loc - 1
        GoTo Fend
    End If
Next wd

Fend:
IsWordInString = wordloc
End Function
