Attribute VB_Name = "LookupMod"
'#################################################################
'##           _      _____ __  __ _           _'
'##     /\   | |    |_   _|  \/  | |         | | ActiveX Control
'##    /  \  | |      | | | \  / | |__   ___ | |_
'##   / /\ \ | |      | | | |\/| | '_ \ / _ \| __|
'##  / ____ \| |____ _| |_| |  | | |_) | (_) | |_
'## /_/    \_\______|_____|_|  |_|_.__/ \___/ \__|
'##
'## Copyright (C) 2002-03, Mohammed Faizul Wahid
'##
'## This program is free software; you can redistribute it and/or
'## modify it under the terms of the GNU General Public License
'## as published by the Free Software Foundation; either version 2
'## of the License, or any later version.
'##
'## All copyright notices regarding ALIMBot ActiveX Control
'## must remain intact in the source code.
'##
'## This program is distributed in the hope that it will be useful,
'## but WITHOUT ANY WARRANTY; without even the implied warranty of
'## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'## GNU General Public License for more details.
'##
'## You should have received a copy of the GNU General Public
'## License along with this program; if not, write to the Free
'## Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
'## MA  02111-1307, USA.
'##
'## Support can be obtained from support forums at:
'## http://faizulwahid.tripod.com/alimbot/
'##
'## Correspondence and Questions can be sent to:
'## faiz_wahid@yahoo.com
'##
'#################################################################
Const WORDMATCH = 100
Const MAXAnswer = 10

'function looks up for keyword in AMC files
Function AnalyseKeywordLookupIn(ByVal strin As String, ByVal strlookupin As String) As String
Dim Qkey As String 'whether keywordvariable, keywordonly, keywordlist etc
Dim strArr() As String
Dim CouldAnswerCorrectly As Boolean
Dim temp, word, lword As Variant
Dim fileinfo() As String
Dim relevance, fileno, L As Integer
Dim linearr() As String
Dim liststr() As String
Dim maxword, matchingwrdsinlst, matchingwrdsinprevlst, matchingwrds As Integer
Dim Answer, Ansarr(MAXAnswer) As String
Dim ans As String
Dim amcfile As String
Dim i, rmax, rnum As Integer
'Initialize
CouldAnswerCorrectly = False
Qkey = Trim(LCase(strlookupin))
L = Len(Qkey)
matchingwrdsinprevlst = 0


'Start

fileinfo = Split(Qkey, "|")
If Not InStr(Trim(fileinfo(0)), ".amc") = 0 Then
    'Complete path of amc file
    amcfile = VariablesMod.AMCDIR & fileinfo(0)
    'Important Step for extracting lookup variables
    strin = DoDeleteCommonWords(strin, VariablesMod.USELESSWORDFILE)
    strin = DoDeleteCommonWords(strin, amcfile)
    '===================================================
    strArr = Split(strin, " ") 'Store the words in strin
    
    fileno = FreeFile
    
    Open amcfile For Input As #fileno
    temp = ""
    
    'Move to the called [general] tag in fileinfo
    While Not Trim(temp) = "[general]" 'Go to that called tag
        Line Input #fileno, temp
    Wend
    
    'check if search is on
    While Not Trim(temp) = ""
        Line Input #fileno, temp
        If Not (IsEmpty(temp) Or IsComment(temp) Or IsKeyTag(temp)) Then
            linearr = Split(Trim(temp), "=")
            If linearr(0) = "search" And linearr(1) = "off" Then
                Close #fileno
                Exit Function
            End If
        End If
    Wend
    
    'Move to the called tag in fileinfo(1)
    While Not Trim(temp) = "[" & Trim(fileinfo(1)) & "]" 'Go to that called tag
        Line Input #fileno, temp
    Wend
    
    ''''GET ANSWER'''''''''
    i = 0
    While Not Trim(temp) = ""
        Line Input #fileno, temp
        matchingwrdsinlst = 0
        maxword = 0

        If Not (IsEmpty(temp) Or IsComment(temp) Or IsKeyTag(temp)) Then
            ans = DoRemoveMultipleSpaces(Trim(temp))
            temp = DoRemovePunctuation(ans)
            linearr = Split(Trim(temp), " ")
            For Each lword In linearr 'for each word in line
                maxword = maxword + 1
                For Each word In strArr 'for each word in input
                    If StrComp(Trim(word), Trim(lword)) = 0 Then
                        'Count number of words in the list match the user input
                        matchingwrdsinlst = matchingwrdsinlst + WORDMATCH + Len(Trim(word))
                    End If
                Next word
            Next lword
        
           'if any words in strin and line match then
            If matchingwrdsinlst > matchingwrdsinprevlst Then
                matchingwrdsinprevlst = matchingwrdsinlst
                Ansarr(i) = ans 'ans is same as temp but is with punctuations
                i = i + 1
                If i > MAXAnswer Then i = MAXAnswer
                CouldAnswerCorrectly = True
            End If
        End If
    Wend
    
    If CouldAnswerCorrectly = True Then
        rmax = i
        rnum = Int(rmax * Rnd)
        Answer = Ansarr(rnum)
    Else
        Answer = ""
    End If

    Close #fileno
    AnalyseKeywordLookupIn = Answer ' Return the answer
End If
'End of IF for keywordlookupin
End Function

'funtion to delete some useless words
'not required for KEYWORD matching
Function DoDeleteCommonWords(ByVal strin As String, ByVal filename As String) As String
Dim strinArr() As String
Dim temp As String
Dim word As Variant
Dim fileno As Integer
Dim max, i As Integer
Dim newstrin As String

newstrin = strin
fileno = FreeFile

strinArr = Split(strin, " ")

max = 0
For Each word In strinArr
    max = max + 1
Next word

Open filename For Input As #fileno
    temp = ""
    'Move to the keytag [replaceinput]
    While Not Trim(temp) = "[uselesswords]" 'Go to that called tag
        Line Input #fileno, temp
    Wend
    
    ''''Replace in strin'''''''''
    i = 0
    While Not temp = ""
        Line Input #fileno, temp
        If Not (IsEmpty(temp) Or IsComment(temp) Or IsKeyTag(temp)) Then
            For i = 0 To max - 1
                If StrComp(strinArr(i), Trim(temp)) = 0 Then
                    strinArr(i) = ""
                End If
            Next
        End If
    Wend
Close #fileno

newstrin = Join(strinArr, " ")
newstrin = DoRemoveMultipleSpaces(newstrin)
'MsgBox "|" & newstrin & "|"
DoDeleteCommonWords = newstrin
End Function
