Attribute VB_Name = "PreProcessingMOD"
'#################################################################
'##           _      _____ __  __ _           _'
'##     /\   | |    |_   _|  \/  | |         | | ActiveX Control
'##    /  \  | |      | | | \  / | |__   ___ | |_
'##   / /\ \ | |      | | | |\/| | '_ \ / _ \| __|
'##  / ____ \| |____ _| |_| |  | | |_) | (_) | |_
'## /_/    \_\______|_____|_|  |_|_.__/ \___/ \__|
'##
'## Copyright (C) 2002-03, Mohammed Faizul Wahid
'##
'## This program is free software; you can redistribute it and/or
'## modify it under the terms of the GNU General Public License
'## as published by the Free Software Foundation; either version 2
'## of the License, or any later version.
'##
'## All copyright notices regarding ALIMBot ActiveX Control
'## must remain intact in the source code.
'##
'## This program is distributed in the hope that it will be useful,
'## but WITHOUT ANY WARRANTY; without even the implied warranty of
'## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'## GNU General Public License for more details.
'##
'## You should have received a copy of the GNU General Public
'## License along with this program; if not, write to the Free
'## Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
'## MA  02111-1307, USA.
'##
'## Support can be obtained from support forums at:
'## http://faizulwahid.tripod.com/alimbot/
'##
'## Correspondence and Questions can be sent to:
'## faiz_wahid@yahoo.com
'##
'#################################################################
'This function removes multiple spaces between
'words in user input and places single spaces
'between them
Function DoRemoveMultipleSpaces(ByVal strin As String) As String
Dim strArr() As String
Dim word As Variant
Dim max, i, newi As Integer

max = 0
strArr = Split(strin, " ")
For Each word In strArr
    max = max + 1
Next word

newi = 0
For i = 0 To max - 1
    If Not strArr(i) = "" Then
        strArr(newi) = strArr(i)
        If Not i = newi Then
            strArr(i) = ""
        End If
        newi = newi + 1
    End If
Next
strin = Trim(Join(strArr, " "))
'MsgBox "|" & strin & "|"
DoRemoveMultipleSpaces = LCase(strin)
End Function

'This function replaces certain shortened
'words in input like "abt" by "about" etc
Function DoReplaceInput(ByVal strin As String) As String
Dim replacearr() As String
Dim strinArr() As String
Dim temp As String
Dim word As Variant
Dim fileno As Integer
Dim max, i As Integer
Dim eError As Boolean
eError = True

newstrin = strin
fileno = FreeFile

strinArr = Split(strin, " ")

max = 0
For Each word In strinArr
    max = max + 1
Next word

On Error GoTo Fend 'else
eError = False
Open VariablesMod.CONFIGDATAFILE For Input As #fileno
    temp = ""
    'Move to the keytag [replaceinput]
    While Not Trim(temp) = "[replaceinput]" 'Go to that called tag
        Line Input #fileno, temp
    Wend
    
    ''''Replace in strin'''''''''
    i = 0
    While Not temp = ""
        Line Input #fileno, temp
        If Not (IsEmpty(temp) Or IsComment(temp) Or IsKeyTag(temp)) Then
            replacearr = Split(Trim(temp), "=")
            For i = 0 To max - 1
                If StrComp(strinArr(i), Trim(replacearr(0))) = 0 Then
                    strinArr(i) = replacearr(1)
                End If
            Next
        End If
    Wend
Close #fileno

newstrin = Join(strinArr, " ")
'MsgBox "|" & newstrin & "|"
DoReplaceInput = newstrin
Fend:
'log error and end function
If eError = True Then
    Call ErrH(eFileOpenError, VariablesMod.CONFIGDATAFILE)
End If
End Function

'funtion to delete some useless words
'not required for PATTERN matching
Function DoDeleteWords(ByVal strin As String) As String
Dim strinArr() As String
Dim temp As String
Dim word As Variant
Dim fileno As Integer
Dim max, i As Integer
Dim newstrin As String

newstrin = strin
fileno = FreeFile

strinArr = Split(strin, " ")

max = 0
For Each word In strinArr
    max = max + 1
Next word

Open VariablesMod.CONFIGDATAFILE For Input As #fileno
    temp = ""
    'Move to the keytag [replaceinput]
    While Not Trim(temp) = "[deletewords]" 'Go to that called tag
        Line Input #fileno, temp
    Wend
    
    ''''Replace in strin'''''''''
    i = 0
    While Not temp = ""
        Line Input #fileno, temp
        If Not (IsEmpty(temp) Or IsComment(temp) Or IsKeyTag(temp)) Then
            For i = 0 To max - 1
                If StrComp(strinArr(i), Trim(temp)) = 0 Then
                    strinArr(i) = ""
                End If
            Next
        End If
    Wend
Close #fileno

newstrin = Join(strinArr, " ")
newstrin = DoRemoveMultipleSpaces(newstrin)
'MsgBox "|" & newstrin & "|"
DoDeleteWords = newstrin
End Function

'This function replaces certain shortened
'words in input like "abt" by "about" etc
Function DoReplaceQuestion(ByVal strin As String) As String
Dim replacearr() As String
Dim temp As String
Dim word As Variant
Dim fileno As Integer
Dim max, i As Integer

newstrin = strin
fileno = FreeFile

Open VariablesMod.CONFIGDATAFILE For Input As #fileno
    temp = ""
    'Move to the keytag [replaceinput]
    While Not Trim(temp) = "[replacequestion]" 'Go to that called tag
        Line Input #fileno, temp
    Wend
    
    ''''Replace in strin'''''''''
    i = 0
    While Not temp = ""
        Line Input #fileno, temp
        If Not (IsEmpty(temp) Or IsComment(temp) Or IsKeyTag(temp)) Then
            replacearr = Split(Trim(temp), "=")
            If StrComp(strin, Trim(replacearr(0))) = 0 Then
                strin = replacearr(1)
            End If
        End If
    Wend
Close #fileno

newstrin = strin
'MsgBox "|" & newstrin & "|"
DoReplaceQuestion = newstrin
End Function

'Function to remove punctuations from sentence
Function DoRemovePunctuation(ByVal str As String) As String
Dim arr As String
Dim i As Integer

arr = "~!#%^&*()_-+|\/[];:'<>?.,"

For i = 1 To Len(arr)
    str = Replace(str, Mid(arr, i, 1), " ")
Next i

'Remove " i.e. double quotes
str = Replace(str, Chr(34), " ")

str = DoRemoveMultipleSpaces(str)
DoRemovePunctuation = str
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Checks for spelling in given string and prompts
'user for correct spelling. If user accepts then
'it returns new string with correct spelling.
'Added on 13th August 2002 by MFW
''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function DoSpellCheck(ByVal str As String) As String
Dim strArr() As String
Dim wordarr() As String
Dim newstrarr() As String
Dim closeness() As String
Dim newstr As String
Dim temp As Variant
Dim word As Variant
Dim strword As Variant
Dim fileno As Integer
Dim i, max As Integer
fileno = FreeFile

strArr = Split(Trim(str), " ")
newstrarr = Split(Trim(str), " ")
closeness = Split(Trim(str), " ")
'count the words in given string
max = -1
For Each word In strArr
    max = max + 1
    newstrarr(max) = "NOMATCH"
Next word

Open VariablesMod.SPELLIST For Input As #fileno
    While Not EOF(fileno)
        Line Input #fileno, temp
        If Not Trim(temp) = "" Then
            wordarr = Split(Trim(temp), ",")
            For Each word In wordarr
                For i = 0 To max
                    If StrComp(LCase(Trim(word)), LCase(Trim(strArr(i)))) = 0 Then
                        newstrarr(i) = strArr(i)
                    End If
                Next i
            Next word
        End If
    Wend
Close #fileno
newstr = Join(newstrarr, " ")
MsgBox newstr
End Function
