VERSION 5.00
Begin VB.UserControl Abot 
   ClientHeight    =   4125
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3210
   InvisibleAtRuntime=   -1  'True
   Picture         =   "ABot.ctx":0000
   ScaleHeight     =   4125
   ScaleWidth      =   3210
End
Attribute VB_Name = "Abot"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'#################################################################
'##           _      _____ __  __ _           _'
'##     /\   | |    |_   _|  \/  | |         | | ActiveX Control
'##    /  \  | |      | | | \  / | |__   ___ | |_
'##   / /\ \ | |      | | | |\/| | '_ \ / _ \| __|
'##  / ____ \| |____ _| |_| |  | | |_) | (_) | |_
'## /_/    \_\______|_____|_|  |_|_.__/ \___/ \__|
'##
'## Copyright (C) 2002-03, Mohammed Faizul Wahid
'##
'## This program is free software; you can redistribute it and/or
'## modify it under the terms of the GNU General Public License
'## as published by the Free Software Foundation; either version 2
'## of the License, or any later version.
'##
'## All copyright notices regarding ALIMBot ActiveX Control
'## must remain intact in the source code.
'##
'## This program is distributed in the hope that it will be useful,
'## but WITHOUT ANY WARRANTY; without even the implied warranty of
'## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'## GNU General Public License for more details.
'##
'## You should have received a copy of the GNU General Public
'## License along with this program; if not, write to the Free
'## Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
'## MA  02111-1307, USA.
'##
'## Support can be obtained from support forums at:
'## http://faizulwahid.tripod.com/alimbot/
'##
'## Correspondence and Questions can be sent to:
'## faiz_wahid@yahoo.com
'##
'###################################################################
'Constants
Private Const AbotDocURL = "http://faizulwahid.tripod.com/alimbot"

Private Sub UserControl_Initialize()
'Default Settings
VariablesMod.CONFIGDATAFILE = App.Path & "\data.dat"
VariablesMod.AMCDIR = App.Path & "\amc\"
VariablesMod.OPTIONFILE = App.Path & "\option.tmp"
VariablesMod.USELESSWORDFILE = App.Path & "\amc\useless.dat"
VariablesMod.TRACELOGFILE = App.Path & "\tracefile.log"
VariablesMod.DEADLOGFILE = App.Path & "\dead.log"
VariablesMod.CURRCHATFILE = App.Path & "\chat.log"


'Actually Get file paths & log options from data.dat file
Call GetConfiguration
End Sub

'''''''''''''''''''''''''''''''''''''''
'Properties of the Control
'''''''''''''''''''''''''''''''''''''''

Property Let SetConfigDataFile(ByVal strfilepath As String)
    VariablesMod.CONFIGDATAFILE = strfilepath
End Property

Property Let SetAMCDir(ByVal strdirpath As String)
    VariablesMod.AMCDIR = strfilepath
End Property

Property Let SetCurrentChatFile(ByVal strfilepath As String)
    VariablesMod.CURRCHATFILE = strfilepath
End Property

Property Let SetDeadLogFile(ByVal strfilepath As String)
    VariablesMod.DEADLOGFILE = strfilepath
End Property

Property Let SetTraceLogFile(ByVal strfilepath As String)
    VariablesMod.TRACELOGFILE = strfilepath
End Property

'Set or Reset Logging of files
Property Let SetLogOn(ByVal tvalue As Boolean)
    VariablesMod.CFGCHATLOG = tvalue
    VariablesMod.CFGTRACELOG = tvalue
    VariablesMod.CFGDEADLOG = tvalue
End Property

Property Let OutputType(ByVal tint As Integer)
    'tint can be only 0,1 or 2
    '0 for plain text, 1 for RTF and 2 for HTML
    If tint >= 0 And tint <= 2 Then
        pOutputType = tint
    Else
        Call ErrH(eOutputTypeNotSet, "")
    End If
End Property
Property Get GetConfigDataFile() As String
    GetConfigDataFile = VariablesMod.CONFIGDATAFILE
End Property
Property Get GetAnswer(ByVal strin As String) As String
    GetAnswer = GetResponse(strin)
End Property


Property Get GetUserName() As String
GetUserName = VariablesMod.USERNAME
End Property

Property Let SetUserName(ByVal uname As String)
Dim fileno As Integer
VariablesMod.USERNAME = uname
VariablesMod.USERMEMFILE = VariablesMod.AMCDIR & uname & ".mem"
'if the file does not exists then create one
If Not Dir(VariablesMod.USERMEMFILE) = uname & ".mem" Then
    fileno = FreeFile
    Open VariablesMod.USERMEMFILE For Append As #fileno
        Print #fileno, "#ALIMbot MEMory File created for User: " & uname
        Print #fileno, "#Created : " & Date & " (" & Time & ")"
        Print #fileno, "#This file was automatically created and is updated by the ALIMbot."
        Print #fileno, "#Change the contents of this file only after reading"
        Print #fileno, "#the documentation at " & AbotDocURL
        Print #fileno, "#--------------------------------------------------------------------" & vbNewLine
    Close #fileno
End If
End Property

Property Get GetBotName() As String
GetBotName = VariablesMod.CFGALIMbotNAME
End Property

Property Let SetBotName(ByVal bname As String)
VariablesMod.CFGALIMbotNAME = bname
End Property

Property Get GetCurrChatTopic() As String
GetCurrChatTopic = VariablesMod.pCurrChatTopic
End Property

Private Sub UserControl_Resize()
UserControl.Height = 495
UserControl.Width = 510
End Sub
